diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderGeometry.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderGeometry.java
index bbe76d47a..78f642142 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderGeometry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderGeometry.java
@@ -28,6 +28,7 @@ public class ShaderGeometry extends Shader{
 
     @Override
     public @NotNull Shader compile(@NotNull ShaderProvider folder, @NotNull String name) {
+        if (!supported) return this;
         OpenGLHelper.checkError("pre compile shader " + name);
 
         delete();
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java
index 097189cc0..7d1f69138 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java
@@ -7,9 +7,8 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.HumanArmorShape;
-import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.ItemStack;
 
 public abstract class Shaders {
@@ -83,9 +82,9 @@ public abstract class Shaders {
 		int isEyeInLiquid = 0;
 		float celestialAngle = 0.0f;
 		if(minecraft.thePlayer != null && minecraft.currentWorld != null && minecraft.activeCamera != null) {
-			if(CameraUtil.isUnderLiquid(minecraft.activeCamera, minecraft.currentWorld, Material.lava, partialTicks)) {
+			if(CameraUtil.isUnderLiquid(minecraft.activeCamera, minecraft.currentWorld, Materials.LAVA, partialTicks)) {
 				isEyeInLiquid = 2;
-			}else if(CameraUtil.isUnderLiquid(minecraft.activeCamera, minecraft.currentWorld, Material.water, partialTicks)) {
+			}else if(CameraUtil.isUnderLiquid(minecraft.activeCamera, minecraft.currentWorld, Materials.WATER, partialTicks)) {
 				isEyeInLiquid = 1;
 			}
 			celestialAngle = minecraft.currentWorld.getCelestialAngle(partialTicks);
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
index 86e261f49..0bb681523 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
@@ -14,6 +14,7 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.ParticleTessellator;
 import net.minecraft.client.render.tessellator.ShaderParticleTessellator;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.material.Materials;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Matrix4f;
 import org.lwjgl.opengl.GL30;
@@ -24,7 +25,6 @@ import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.Renderer;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.camera.CameraUtil;
-import net.minecraft.core.block.material.Material;
 import org.lwjgl.system.MemoryUtil;
 import org.slf4j.Logger;
 
@@ -65,9 +65,12 @@ public class ShadersRenderer implements Renderer {
         if (!Shaders.enableShaders) throw new RuntimeException("Shaders disabled!");
         if (OpenGLHelper.gl32) {
             this.vao = GL30.glGenVertexArrays();
-            this.particleShader.enabled = true;
+            this.particleShader.supported = true;
+            LOGGER.info("GL32 supported, enabling particle geometry shaders");
         } else {
             this.vao = 0;
+            this.particleShader.supported = false;
+            LOGGER.info("GL32 not supported, disabling particle geometry shaders");
         }
     }
 
@@ -152,9 +155,9 @@ public class ShadersRenderer implements Renderer {
             glUniformMatrix4fv(this.cloudsShader.getUniform("gbufferProjectionInverse"), false, this.matrixBuffer);
 
             int isEyeInLiquid;
-            if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Material.lava, partialTicks)) {
+            if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.LAVA, partialTicks)) {
                 isEyeInLiquid = 2;
-            } else if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Material.water, partialTicks)) {
+            } else if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.WATER, partialTicks)) {
                 isEyeInLiquid = 1;
             } else {
                 isEyeInLiquid = 0;
@@ -213,8 +216,10 @@ public class ShadersRenderer implements Renderer {
 
     @Override
     public void endRenderParticles(float partialTicks) {
-        glUseProgram(0);
-        GL30.glBindVertexArray(0);
+        if (this.particleShader.isEnabled()) {
+            glUseProgram(0);
+            GL30.glBindVertexArray(0);
+        }
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
index 17cc19e67..1741688fe 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -5,6 +5,10 @@ import java.util.List;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBf;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.render.block.model.BlockModel;
@@ -14,14 +18,12 @@ import net.minecraft.client.render.entity.EntityRendererItem;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
-public abstract class ChunkRenderer
-{
+public abstract class ChunkRenderer {
     public static final int MAX_RENDER_PASSES = 2;
     public static int updates = 0;
-    
+
     public World world;
     protected final int lists;
     public int posX;
@@ -43,147 +45,127 @@ public abstract class ChunkRenderer
     public int zm;
     public float radius;
     public boolean dirty;
-    public AABB bb;
+    public AABBf bb;
     public int id;
     public boolean occlusionVisible;
     public boolean occlusionQuerying;
     public int occlusionId;
     public boolean skyLit;
     protected boolean compiled;
-    public List<TileEntity> renderableBlockEntities;
-    protected final List<TileEntity> globalRenderableBlockEntities;
-
-    public ChunkRenderer(World world, List<TileEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists)
-    {
-        visible = false;
-        empty = new boolean[MAX_RENDER_PASSES];
-        occlusionVisible = true;
-        compiled = false;
-        renderableBlockEntities = new ArrayList<>();
+    public @NotNull List<@NotNull TileEntity> renderableBlockEntities;
+    protected final @NotNull List<@NotNull TileEntity> globalRenderableBlockEntities;
+
+    public ChunkRenderer(@NotNull World world, @NotNull List<@NotNull TileEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists) {
+        this.visible = false;
+        this.empty = new boolean[MAX_RENDER_PASSES];
+        this.occlusionVisible = true;
+        this.compiled = false;
+        this.renderableBlockEntities = new ArrayList<>();
         this.world = world;
-        globalRenderableBlockEntities = globalRenderableTileEntities;
-        sizeX = sizeY = sizeZ = size;
-        radius = MathHelper.sqrt_float(sizeX * sizeX + sizeY * sizeY + sizeZ * sizeZ) / 2.0F;
+        this.globalRenderableBlockEntities = globalRenderableTileEntities;
+        this.sizeX = this.sizeY = this.sizeZ = size;
+        this.radius = MathHelper.sqrt_float(this.sizeX * this.sizeX + this.sizeY * this.sizeY + this.sizeZ * this.sizeZ) / 2.0F;
         this.lists = lists;
         this.posX = -999;
         setPos(x, y, z);
-        dirty = false;
+        this.dirty = false;
     }
 
-    public void setPos(int x, int y, int z)
-    {
-        if (x != this.posX || y != this.posY || z != this.posZ)
-        {
+    public void setPos(int x, int y, int z) {
+        if (x != this.posX || y != this.posY || z != this.posZ) {
             reset();
             this.posX = x;
             this.posY = y;
             this.posZ = z;
-            xm = x + sizeX / 2;
-            ym = y + sizeY / 2;
-            zm = z + sizeZ / 2;
-            xRenderOffs = x & 0x3ff;
-            yRenderOffs = y;
-            zRenderOffs = z & 0x3ff;
-            xRender = x - xRenderOffs;
-            yRender = y - yRenderOffs;
-            zRender = z - zRenderOffs;
+            this.xm = x + this.sizeX / 2;
+            this.ym = y + this.sizeY / 2;
+            this.zm = z + this.sizeZ / 2;
+            this.xRenderOffs = x & 0x3ff;
+            this.yRenderOffs = y;
+            this.zRenderOffs = z & 0x3ff;
+            this.xRender = x - this.xRenderOffs;
+            this.yRender = y - this.yRenderOffs;
+            this.zRender = z - this.zRenderOffs;
             float f = 6F;
-            bb = AABB.fromPool((float)x - f, (float)y - f, (float)z - f, (float)(x + sizeX) + f, (float)(y + sizeY) + f, (float)(z + sizeZ) + f).copyUnpooled();
-            GL11.glNewList(lists + MAX_RENDER_PASSES, GL11.GL_COMPILE);
-            EntityRendererItem.renderFlatAABB(AABB.fromPool((float) xRenderOffs - f, (float) yRenderOffs - f, (float) zRenderOffs - f, (float)(xRenderOffs + sizeX) + f, (float)(yRenderOffs + sizeY) + f, (float)(zRenderOffs + sizeZ) + f));
+            this.bb = new AABBf(x - f, y - f,  z - f, (x + this.sizeX) + f, (y + this.sizeY) + f, (z + this.sizeZ) + f);
+            GL11.glNewList(this.lists + MAX_RENDER_PASSES, GL11.GL_COMPILE);
+            EntityRendererItem.renderFlatAABB(new AABBd( this.xRenderOffs - f, this.yRenderOffs - f, this.zRenderOffs - f, (this.xRenderOffs + this.sizeX) + f, (this.yRenderOffs + this.sizeY) + f, (this.zRenderOffs + this.sizeZ) + f));
             GL11.glEndList();
             setDirty();
         }
     }
-    
+
     public abstract boolean rebuild(boolean priority);
-    
-    public boolean renderBlock(Tessellator tessellator, WorldSource worldSource, BlockModel<?> model, int x, int y, int z) {
-    	boolean rendered = false;
-		rendered |= model.render(tessellator, worldSource, x, y, z);
-		if(model.hasOverbright()) {
-			rendered |= model.renderOverbright(tessellator, worldSource, x, y, z);
-		}
-		return rendered;
+
+    public boolean renderBlock(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModel<?> model, @NotNull TilePos tilePos) {
+        boolean rendered = false;
+        rendered |= model.render(tessellator, worldSource, tilePos);
+        if (model.hasOverbright()) {
+            rendered |= model.renderOverbright(tessellator, worldSource, tilePos);
+        }
+        return rendered;
     }
 
-    protected void translateToPos()
-    {
-        GL11.glTranslatef(xRenderOffs, yRenderOffs, zRenderOffs);
+    protected void translateToPos() {
+        GL11.glTranslatef(this.xRenderOffs, this.yRenderOffs, this.zRenderOffs);
     }
 
-    public float distanceToEntitySquared(Entity entity)
-    {
-        float dx = (float)(entity.x - (double) xm);
-        float dy = (float)(entity.y - (double) ym);
-        float dz = (float)(entity.z - (double) zm);
+    public float distanceToEntitySquared(Entity entity) {
+        float dx = (float) (entity.x - (double) this.xm);
+        float dy = (float) (entity.y - (double) this.ym);
+        float dz = (float) (entity.z - (double) this.zm);
         return dx * dx + dy * dy + dz * dz;
     }
 
-    public float distanceToCameraSquared(ICamera camera)
-    {
-        float dx = (float)(camera.getX(1f) - xm);
-        float dy = (float)(camera.getY(1f) - ym);
-        float dz = (float)(camera.getZ(1f) - zm);
+    public float distanceToCameraSquared(ICamera camera) {
+        float dx = (float) (camera.getX(1f) - this.xm);
+        float dy = (float) (camera.getY(1f) - this.ym);
+        float dz = (float) (camera.getZ(1f) - this.zm);
         return dx * dx + dy * dy + dz * dz;
     }
 
-    public void reset()
-    {
-        for(int i = 0; i < MAX_RENDER_PASSES; i++)
-        {
-            empty[i] = true;
+    public void reset() {
+        for (int i = 0; i < MAX_RENDER_PASSES; i++) {
+            this.empty[i] = true;
         }
 
-        visible = false;
-        compiled = false;
+        this.visible = false;
+        this.compiled = false;
     }
 
-    public void delete()
-    {
+    public void delete() {
         reset();
-        world = null;
+        this.world = null;
     }
 
-    public int getList(int layer)
-    {
-        if(!visible)
-        {
+    public int getList(int layer) {
+        if (!this.visible) {
             return -1;
         }
-        if(!empty[layer])
-        {
-            return lists + layer;
-        } 
-        else
-        {
+        if (!this.empty[layer]) {
+            return this.lists + layer;
+        } else {
             return -1;
         }
     }
 
-    public void cull(CameraFrustum frustum, float partialTick)
-    {
-        visible = true/*frustum.isVisible(bb, partialTick)*/;
+    public void cull(CameraFrustum frustum, float partialTick) {
+        this.visible = true/*frustum.isVisible(bb, partialTick)*/;
     }
 
-    public void renderBB()
-    {
-        GL11.glCallList(lists + MAX_RENDER_PASSES);
+    public void renderBB() {
+        GL11.glCallList(this.lists + MAX_RENDER_PASSES);
     }
 
-    public boolean isEmpty()
-    {
-        if(!compiled)
-        {
+    public boolean isEmpty() {
+        if (!this.compiled) {
             return false;
-        } else
-        {
-            return empty[0] && empty[1];
+        } else {
+            return this.empty[0] && this.empty[1];
         }
     }
 
-    public void setDirty()
-    {
-        dirty = true;
+    public void setDirty() {
+        this.dirty = true;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
index 0d40a5209..dbd698ea8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
@@ -20,92 +20,93 @@ import net.minecraft.core.world.chunk.ChunkCache;
 
 public class ChunkRendererLegacy extends ChunkRenderer {
 
-	public ChunkRendererLegacy(World world, List<TileEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists) {
-		super(world, globalRenderableTileEntities, x, y, z, size, lists);
-	}
-
-	@Override
-    public boolean rebuild(boolean priority)
-    {
-        if(!dirty) { return false; }
-        final int minX = posX;
-        final int minY = posY;
-        final int minZ = posZ;
-        final int maxX = posX + sizeX;
-        final int maxY = posY + sizeY;
-        final int maxZ = posZ + sizeZ;
+    public ChunkRendererLegacy(World world, List<TileEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists) {
+        super(world, globalRenderableTileEntities, x, y, z, size, lists);
+    }
+
+    @Override
+    public boolean rebuild(boolean priority) {
+        if (!this.dirty) {
+            return false;
+        }
+        final int minX = this.posX;
+        final int minY = this.posY;
+        final int minZ = this.posZ;
+        final int maxX = this.posX + this.sizeX;
+        final int maxY = this.posY + this.sizeY;
+        final int maxZ = this.posZ + this.sizeZ;
 
         final int cacheRadius = 1;
-        final ChunkCache chunkcache = new ChunkCache(world, new TilePos(minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius), new TilePos(maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius), priority);
+        final ChunkCache chunkcache = new ChunkCache(this.world, new TilePos(minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius), new TilePos(maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius), priority);
         if (!chunkcache.allLoaded()) return false;
 
-        for(int i = 0; i < MAX_RENDER_PASSES; i++) { empty[i] = true; }
+        for (int i = 0; i < MAX_RENDER_PASSES; i++) {
+            this.empty[i] = true;
+        }
 
         Chunk.isLit = false;
-        final Set<TileEntity> lastSpecialTileEntities = new HashSet<>(renderableBlockEntities);
-        renderableBlockEntities.clear();
+        final Set<TileEntity> lastSpecialTileEntities = new HashSet<>(this.renderableBlockEntities);
+        this.renderableBlockEntities.clear();
         updates++;
 
         int renderPass = 0;
         Tessellator tessellator = Tessellator.instance;
-        do
-        {
-            if(renderPass >= MAX_RENDER_PASSES) { break; }
+        do {
+            if (renderPass >= MAX_RENDER_PASSES) {
+                break;
+            }
 
             boolean needsMoreRenderPasses = false;
             boolean hasRenderedBlock = false;
             boolean hasStartedDrawing = false;
 
-            for(int y = minY; y < maxY; y++)
-            {
-                for(int z = minZ; z < maxZ; z++)
-                {
-                    for(int x = minX; x < maxX; x++)
-                    {
-                        final int blockId = chunkcache.getBlockId(x, y, z);
-                        if(blockId <= 0) {
+            TilePos pos = new TilePos(0, 0, 0);
+            for (pos.y = minY; pos.y < maxY; pos.y++) {
+                for (pos.z = minZ; pos.z < maxZ; pos.z++) {
+                    for (pos.x = minX; pos.x < maxX; pos.x++) {
+                        final int blockId = chunkcache.getBlockId(pos);
+                        if (blockId <= 0) {
                             continue;
                         }
-                        if(!hasStartedDrawing) {
+                        if (!hasStartedDrawing) {
                             hasStartedDrawing = true;
-                            GL11.glNewList(lists + renderPass, GL11.GL_COMPILE);
+                            GL11.glNewList(this.lists + renderPass, GL11.GL_COMPILE);
                             GL11.glPushMatrix();
                             translateToPos();
                             final float scale = 1.000001F;
-                            GL11.glTranslatef((float)(-sizeZ) / 2.0F, (float)(-sizeY) / 2.0F, (float)(-sizeZ) / 2.0F);
+                            GL11.glTranslatef((float) (-this.sizeZ) / 2.0F, (float) (-this.sizeY) / 2.0F, (float) (-this.sizeZ) / 2.0F);
                             GL11.glScalef(scale, scale, scale);
-                            GL11.glTranslatef((float) sizeZ / 2.0F, (float) sizeY / 2.0F, (float) sizeZ / 2.0F);
+                            GL11.glTranslatef((float) this.sizeZ / 2.0F, (float) this.sizeY / 2.0F, (float) this.sizeZ / 2.0F);
                             tessellator.startDrawingQuads();
                             tessellator.setTranslation(-this.posX, -this.posY, -this.posZ);
-                            
-                            if(LightmapHelper.isLightmapEnabled()) {
-                            	// Make sure it's active
-                            	tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
+
+                            if (LightmapHelper.isLightmapEnabled()) {
+                                // Make sure it's active
+                                tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
                             }
                         }
-                        if(renderPass == 0 && Blocks.isEntityTile[blockId]) {
-                            final TileEntity tileentity = chunkcache.getTileEntity(x, y, z);
-                            if(TileEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
-                                renderableBlockEntities.add(tileentity);
+                        if (renderPass == 0 && Blocks.isEntityTile[blockId]) {
+                            final TileEntity tileentity = chunkcache.getTileEntity(pos);
+                            if (tileentity != null && TileEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
+                                this.renderableBlockEntities.add(tileentity);
                             }
                         }
                         final BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[blockId]);
                         final int blockRenderPass = model.renderLayer();
-                        if(blockRenderPass != renderPass) {
+                        if (blockRenderPass != renderPass) {
                             needsMoreRenderPasses = true;
-                        }
-                        else {
-                        	if(LightmapHelper.isLightmapEnabled()) {
-                        		// Can probably be removed once all block models support the lightmap
-                        		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));
-                        	}
+                        } else {
+                            if (LightmapHelper.isLightmapEnabled()) {
+                                // Can probably be removed once all block models support the lightmap
+                                tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));
+                            }
 
-    						hasRenderedBlock |= renderBlock(tessellator, world, model, x, y, z);
+                            hasRenderedBlock |= renderBlock(tessellator, this.world, model, pos);
                         }
                     }
                 }
             }
-            if(hasStartedDrawing) {
+            if (hasStartedDrawing) {
                 tessellator.draw();
                 GL11.glPopMatrix();
                 GL11.glEndList();
@@ -113,23 +114,23 @@ public class ChunkRendererLegacy extends ChunkRenderer {
             } else {
                 hasRenderedBlock = false;
             }
-            
-            if(hasRenderedBlock) {
-                empty[renderPass] = false;
-            }            
-            if(!needsMoreRenderPasses) {
+
+            if (hasRenderedBlock) {
+                this.empty[renderPass] = false;
+            }
+            if (!needsMoreRenderPasses) {
                 break;
             }
-            
+
             renderPass++;
-        } while(true);
-        HashSet<TileEntity> newSpecialTileEntities = new HashSet<>(renderableBlockEntities);
+        } while (true);
+        HashSet<TileEntity> newSpecialTileEntities = new HashSet<>(this.renderableBlockEntities);
         newSpecialTileEntities.removeAll(lastSpecialTileEntities);
-        globalRenderableBlockEntities.addAll(newSpecialTileEntities);
-        renderableBlockEntities.forEach(lastSpecialTileEntities::remove);
-        globalRenderableBlockEntities.removeAll(lastSpecialTileEntities);
-        skyLit = Chunk.isLit;
-        compiled = true;
+        this.globalRenderableBlockEntities.addAll(newSpecialTileEntities);
+        this.renderableBlockEntities.forEach(lastSpecialTileEntities::remove);
+        this.globalRenderableBlockEntities.removeAll(lastSpecialTileEntities);
+        this.skyLit = Chunk.isLit;
+        this.compiled = true;
         return true;
     }
 
